

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Atk.Flags
    ( 

 -- * Flags
-- ** HyperlinkStateFlags #flag:HyperlinkStateFlags#

    HyperlinkStateFlags(..)                 ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- Flags HyperlinkStateFlags
{- |
Describes the type of link
-}
data HyperlinkStateFlags = 
      HyperlinkStateFlagsInline
    {- ^
    Link is inline
    -}
    | AnotherHyperlinkStateFlags Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum HyperlinkStateFlags where
    fromEnum HyperlinkStateFlagsInline = 1
    fromEnum (AnotherHyperlinkStateFlags k) = k

    toEnum 1 = HyperlinkStateFlagsInline
    toEnum k = AnotherHyperlinkStateFlags k

instance P.Ord HyperlinkStateFlags where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

foreign import ccall "atk_hyperlink_state_flags_get_type" c_atk_hyperlink_state_flags_get_type :: 
    IO GType

instance BoxedFlags HyperlinkStateFlags where
    boxedFlagsType _ = c_atk_hyperlink_state_flags_get_type

instance IsGFlag HyperlinkStateFlags


